{ }
(*
	ARERegistryVariable V1.0 by Albert Research 98

	Legal Notice:

	Distribution

	This component is freeware. As such, Albert Research gives no warranty to its accuracy, fitness for any particular use, effects of use, or reliability.
	This component may not be distributed as a part of another component package without Albert Research written consent. It may be freely distributed,
	although it must be distributed with all original files in their original format intact. If you use this component in your software, please include an acknow-
	ledgment that portions are copyrighted by Albert Research. Please contact the author, Albert, at one of the below address with questions, comments, bug-reports
	 or any updates you make to the component.

	 Albert Research:

	 e-mail: albertrs@redestb.es
	 Web: http://personal.redest.es/albertrs



								 ``     ```''MM'``
										``A##NNN````
								   `` ``''#UUMMMNN```
								 ``  'MMAAHRRMMMHHNN```
								   ``R@@##@##MMHHHMMN````
								 ``HHR@@@@@##MMMHHNNNNN``
							  ```AAHH#@@@@@@@MMNNNMMMHHNN`           `
				  ``       `````H##@@H####@##MMMMMHHMHHHHH```` ````
						 `` ''###@@##HHHHHR##MMNNNMMNHHHHNNN`````  ``
				  ```      `UU###@@HH@##RR#RRMMMHHNNNNNMMHHHNN`````  `
						 ``#####@##@@@@@##@##MMMMMNNNHHNNNNNNNN````
					   ````RHH##H#####@@@@@##NNNNNMMMNNNNNNNHHHNN  ``
					   `````''~~~::UU@##RR#RRMMMMMNNMMMMM'''```````
					`##HHHH@HH@@HHHHHHHHNNH@@NNHHH@@HHHHH@##HH#@@##HH`
      `````        ````'####@@###@@H@@HHH@@HHHHHHH@HH@@@@@@@@@@NNMNNHHHHH``
		``     ```##@@@@@##@@@##@@@@@@####@##MMMMMMMNMMMMNMMHHMHHNNNNHNN```
		  `  ```''RR#HH@@@@HRR##@@@@@@@@@@@##MMMNNMMNNNNNNHHMMNNNMMHHNNNHH```  `
		  `    `HHAA@####@@@@@@@H@@@@@@@#####MMNNNMMNNNNNMNNHHNMMNNMMHNNNN'       ``
	  ``   ``  ```''~MM####@HH##@@@@@@@@##@##MMNNNMMNNNNNNNNHHMNNNNMM'''`````  `
	 `    ```##HHH@@@HHHHHHHNNHHHHH@@@@@#####MMMMMMMNNNNN@HH@@@HHHH##H##HHRHHHH```
	  ````M##@@@@@@@@@@@@HHHHHHHHHHHHHHHHHHHH@@H@@@@HHHHHHHH@@@HHNNNNMHHMMNNNHHH````
	  ``''#@@@@@HH@@@@@@@@@@@@@@@HHHHHHHHHHHH@@HHHHHH@@HH@HHNNMMMNNNNHMMHHNNNNNNMM```
      ```MMRR@##@@@@@@@@@@@@HHHHH@@@@@@@@@@@@HHHHH@@@NNMNNMMMMMNNNNNMMMMNMMMMHNNNNMNNNN`
      ''~AA##@##@@H@@@@@@@@@@@@@@@@@@@@@@@@@@@##MMMNNMMNNNMMNNNMMMNNNNNNNNNMMNNNMMNNNNNH
      ~~A@@RRRHHHH#@@@@@@@@@@@@@@@@@@@@@@@@###RRMMMNNHHHNNMMNNNNNNMMMMNNHNNNNNMMHHMNNNNN@@
      ``'@@##@RR##H@@@@@@@####@##@@@@@@@@@@###@@MMMMMMMNNNHHNNNNNNNNNNNNNNNMMHNNNNHMMHH```
		  ```''M####@##HH##H@@HH#@@HH@HHHH#@@NNNNNNNNNNNNMMMNNNMMNNMMNHHNNN`````  ``
		   ```````MMRRRRR@@#HH@@@##HHH@@HHRRRMMMNNNNMNNNNNMMNNNMMNNHHHNN`````
      ```    ```       `````''R####A@@###HH@@@##MMNMMNNMNNHHNHHNNN``````     `
		   ``               ```````##R@@@@@@@HHMNNNNHNN```       ``
	  ``                         ``'''MMAA#RRMMNHHMM`````          ``   ``
										   ``''     `

*)
{ }

{V1.0... Initial Release}

unit ARERegistryVariable;

interface
                                                          
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,Registry,dsgnintf,StdCtrls,ExtCtrls,ShellApi,comctrls,imgList;

type
	TAboutProperty = class(TPropertyEditor)
		public
			procedure Edit; override;
			function GetAttributes: TPropertyAttributes; override;
			function GetValue: string; override;
		end;

	TDialogComponent=class(TDefaultEditor)
		public
			procedure ExecuteVerb(Index: Integer); override;
			function GetVerb(Index: Integer): string; override;
			function GetVerbCount: Integer; override;
			procedure CopyRight;
			procedure DeleteKeyAtRegistry;
			procedure DeleteVariable;
			procedure ImportFile;
			procedure ExportFile;
			procedure ShowValue;
		end;

	TARUrlType = (url_http,url_mailto);

	TARUrlLabel = class(TLabel)
		private
			VUrl					: string;
			VUrlType				: TARUrlType;
			procedure AR_DoClick(Sender:TObject);
			procedure PSetVUrl(Value: string);
			procedure PSetVUrlType(Value: TARUrlType);
		protected
		public
			constructor Create(AOwner : TComponent);override;
			destructor Destroy; override;
		published
			property URL : string read VUrl write PSetVUrl;
			property URLType: TARUrlType read VUrlType write PSetVUrlType;
	end;


	TARERegistryVariable = class;

	TRegistryKeys = class;

	{Each Single Key Item at the Collection}
	TRegistryKey = class (TCollectionItem)
	private
		{ Private declarations }
		V_RegistryKey : string;
		V_CreateKey: boolean;
		procedure PSetV_RegistryKey(const Value: string);
		procedure PSetV_CreateKey(const Value: boolean);
	protected
		{ Protected declarations }
		procedure DefineProperties(Filer: TFiler); override;
		function  GetDisplayName: string; override;
	public
		{ Public declarations }
		constructor Create(Collection: TCollection); override;
		destructor Destroy; override;
		procedure Assign(Source: TPersistent); override;
	published
		{ Published declarations }
		property RegistryKey : string read V_RegistryKey write PSetV_RegistryKey;
		property CreateKey: boolean read V_CreateKey write PSetV_CreateKey;
	end;

	{The Collection that group the individual keys}
	TRegistryKeys = class (TCollection)
	private
		{ Private declarations }
		V_Owner : TARERegistryVariable;
		function GetItem(Index: Integer): TRegistryKey;
		procedure SetItem(Index: Integer; Value: TRegistryKey);

	protected
		{ Protected declarations }
		function GetOwner: TPersistent; override;
		procedure Update(Item: TCollectionItem); override;

	public
		{ Public declarations }
		constructor Create(AOwner: TARERegistryVariable);
		function Add : TRegistryKey;
		property ARERegistryVariable: TARERegistryVariable read V_Owner;
		property Items[Index: Integer]: TRegistryKey read GetItem write SetItem; default;
	published
		{ Published declarations }
	end;

	{Sets of several values of the object}
	TRootRegistryKey = (rgk_HKEY_CLASSES_ROOT,rgk_HKEY_CURRENT_USER,rgk_HKEY_LOCAL_MACHINE,rgk_HKEY_CURRENT_CONFIG);
	TVariableType = (rvt_Bool,rvt_Currency,rvt_Date,rvt_DateTime,rvt_Time,rvt_Float,rvt_Integer,rvt_String);
	TARERegistryErrorType = (AR_ErrorNone,ERR_Read_KeyNotFound,ERR_Read_ValueNotFound,ERR_Write_KeyNotFound,ERR_Write_Value,ERR_Delete_KeyNotFound,ERR_Delete_ValueNotFound);
	TARERegistryErrorNotify = procedure (Sender: TObject; ErrorType: TARERegistryErrorType; Param: string) of object;


	TARERegistryVariable  = class(TComponent)
	private
		{ Private declarations }
		V_RootRegistryKey : TRootRegistryKey;
		V_RegistryKeys: TRegistryKeys;
		V_VariableName: string;
		V_VariableType: TVariableType;
		V_WriteOnDef : boolean;
		V_ErrorNotify: TAREregistryErrorNotify;
		V_About: TAboutProperty;

		V_Form					: TForm;
		V_RBT_VariableType		: array[1..8] of TRadioButton;
		V_PAN_Form				: TPanel;
		V_BTN_Ok				: TButton;
		V_LAB_Text				: TLabel;
		V_EDT_Value				: TEdit;		
		V_TRV_Registry			: TTreeView;
		V_Node					: TTreeNode;
		IML_TRV_Registry		: TImageList;


		procedure Copyright;
		procedure PSetV_RootRegistryKey(const Value: TRootRegistryKey);
		procedure PSetV_RegistryKeys(const Value: TRegistryKeys);
		procedure PSetV_VariableName(const Value: string);
		procedure PSetV_VariableType(const Value: TVariableType);
		procedure PSetV_WriteOnDef(const Value: boolean);
		procedure DeleteKeyAtRegistry(Index: integer);
		function V_KeyCount: integer;
		procedure ImportFile(V_KeyString: string; V_ValueString: string);
		procedure ExportFile;
		procedure ShowValue;		
		procedure AR_FormCloseImportFile(Sender: TObject; var Action: TCloseAction);
		procedure AR_BTNOkClick(Sender: TObject);
		procedure AR_RBTClick(Sender: TObject);
	protected
		{ Protected declarations }
		procedure Loaded; override;
	public
		{ Public declarations }
		constructor Create(AOwner : TComponent);override;
		destructor Destroy; override;
		function Read: Variant;
		function ReadDef(DefaultRead: Variant): Variant;
		procedure Write(Value: Variant);
		procedure DeleteVariable;
		function ExistVariable:boolean;
	published
		{ Published declarations }
		{Properties}
		property Author: TAboutProperty read V_About write V_About;
		property RootKey : TRootRegistryKey read V_RootREgistryKey write PSetV_RootRegistryKey;
		property Keys: TRegistryKeys read V_RegistryKeys write PSetV_RegistryKeys;
		property VariableName: string read V_VariableName write PSetV_VariableName;
		property VariableType: TVariableType read V_VariableType write PSetV_VariableType;
		property WriteOnDef: boolean read V_WriteOnDef write PSetV_WriteOnDef;
		property KeyCount: integer read V_KeyCount;
		{Events}
		property OnError: TAREregistryErrorNotify read V_ErrorNotify write V_ErrorNotify;



	end;

procedure Register;

implementation

const

(* Image Information *)
// Height	: 016
// Width 	: 016

	V_FolderHeight			= 016;
	V_FolderWidth			= 016;
	V_Folder					: array[1..256] of DWord = (
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00848484,$00C6C6C6,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00848484,$00C6C6C6,$0000FFFF,$00FFFFFF,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00848484,$0000FFFF,$00C6C6C6,$00FFFFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00848484,$00C6C6C6,$0000FFFF,$00FFFFFF,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00848484,$0000FFFF,$00C6C6C6,$00FFFFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00848484,$00C6C6C6,$0000FFFF,$00FFFFFF,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00848484,$00C6C6C6,$00FFFFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00FFFFFF,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00FFFFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00FFFFFF,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00FFFFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00FFFFFF,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00C6C6C6,$0000FFFF,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF);
(* Image Information *)
// Height	: 016
// Width 	: 016

	V_BinaryHeight			= 016;
	V_BinaryWidth			= 016;
	V_Binary					: array[1..256] of DWord = (
												   $00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FF0000,$00FF0000,$00FFFFFF,$00FFFFFF,$00FF0000,$00FF0000,$00FF0000,$00FF0000,$00FFFFFF,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FF0000,$00FF0000,$00FF0000,$00FF0000,$00FFFFFF,$00FF0000,$00FF0000,$00FF0000,$00FF0000,$00FFFFFF,$00C6C6C6,$00848484,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FF0000,$00FFFFFF,$00FFFFFF,$00FF0000,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FF0000,$00FF0000,$00FF0000,$00FF0000,$00FFFFFF,$00FF0000,$00FF0000,$00FF0000,$00FF0000,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FF0000,$00FF0000,$00FFFFFF,$00FFFFFF,$00FF0000,$00FF0000,$00FF0000,$00FF0000,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00000000,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FF0000,$00FF0000,$00FF0000,$00FF0000,$00FFFFFF,$00FFFFFF,$00FF0000,$00FF0000,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FF0000,$00FF0000,$00FF0000,$00FF0000,$00FFFFFF,$00FF0000,$00FF0000,$00FF0000,$00FF0000,$00C6C6C6,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FF0000,$00FFFFFF,$00FFFFFF,$00FF0000,$00C6C6C6,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FF0000,$00FF0000,$00FF0000,$00FF0000,$00FFFFFF,$00FF0000,$00FF0000,$00FF0000,$00FF0000,$00C6C6C6,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00848484,$00848484,$00848484,$00FF0000,$00FF0000,$00FF0000,$00FFFFFF,$00FFFFFF,$00FF0000,$00FF0000,$00FFFFFF,$00FFFFFF,$00848484,$00000000,$00FFFFFF,
												   $00FFFFFF,$00848484,$00FFFFFF,$00000000,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00000000,
												   $00FFFFFF,$00FFFFFF,$00848484,$00000000,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00000000,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000);
(* Image Information *)
// Height	: 016
// Width 	: 016

	V_StringHeight			= 016;
	V_StringWidth			= 016;
	V_String					: array[1..256] of DWord = (
												   $00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00848484,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000084,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000084,$00FFFFFF,$00000084,$00000084,$00000084,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00848484,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000084,$00FFFFFF,$00000084,$00FFFFFF,$00000084,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000084,$00000084,$00000084,$00000084,$00000084,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00000084,$00000084,$00000084,$00000084,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000084,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00000000,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00000084,$00000084,$00000084,$00000084,$00000084,$00000084,$00000084,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00000084,$00000084,$00000084,$00000084,$00000084,$00000084,$00000084,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000084,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000084,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000084,$00000084,$00000084,$00000084,$00000084,$00FFFFFF,$00FFFFFF,$00C6C6C6,$00000000,$00FFFFFF,$00FFFFFF,
												   $00848484,$00848484,$00848484,$00848484,$00FFFFFF,$00FFFFFF,$00000084,$00000084,$00000084,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00000000,$00FFFFFF,
												   $00FFFFFF,$00848484,$00FFFFFF,$00000000,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00848484,$00000000,
												   $00FFFFFF,$00FFFFFF,$00848484,$00000000,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00C6C6C6,$00000000,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000,$00000000);

	V_AlbertResearchHeight			= 050;
	V_AlbertResearchWidth			= 050;
	V_AlbertResearch					: array[1..2500] of DWord = (
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00529C5A,$005A9C63,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00185218,$0052A55A,$00429C4A,$00428C42,$004A8452,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$005A945A,$00529C52,$0042A54A,$00319C39,$0042A54A,$004A9452,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00216B21,$00429C42,$00399439,$00429C39,$0039A539,$0039AD39,$0042B542,$00399439,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00428C42,$0042A542,$0039A539,$0042A539,$0042AD42,$0042B539,$0029A529,$00219C21,$0042AD42,$00529C52,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A8C4A,$0042AD42,$0031A531,$0031AD29,$0031A529,$0031A531,$0031AD31,$0031AD29,$0029AD29,$0039AD39,$00429C42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00398C39,$0039AD39,$0029AD29,$0029AD29,$0031A529,$0031AD31,$0029A529,$0031B531,$0039BD39,$0029A529,$0042A542,$00216B21,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00639452,$00396B31,$000000FF,$000000FF,$00318C39,$0031A539,$0031AD31,$0029AD29,$0031AD31,$0039AD31,$0039AD31,$0039AD31,$0031B531,$0031AD31,$0039A539,$00429C4A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A944A,$004AA54A,$0052A542,$005AA552,$000000FF,$00317339,$00429C42,$00299C31,$0031AD31,$0031AD31,$0031AD31,$0039AD31,$0039A531,$0031AD31,$0031AD31,$0031AD31,$0039AD39,$00429C42,$00215A21,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A9C52,$00399C39,$0039AD39,$0042AD42,$00399C39,$000000FF,$00398442,$00429442,$00298C29,$0039A539,$0031A539,$0031AD31,$0031AD31,$0039A531,$0031A531,$0031A531,$0031A531,$0031A531,$00399C39,$00529C52,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00528452,$004A9C4A,$0039A539,$0031AD39,$0029A529,$0031AD39,$0042A542,$00187318,$00429442,$00398C39,$00399431,$0039A539,$0039A539,$0039AD39,$0031AD31,$0039A539,$0039A539,$0039A539,$0039AD39,$0031AD31,$0039AD42,$004AA552,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00398439,$0042A542,$0031AD31,$0029B531,$0029AD31,$0039AD42,$0039A542,$0042A542,$00319431,$00399431,$00399431,$00399C39,$0039A539,$0031AD31,$0031AD31,$0031AD31,$0039AD39,$0039A539,$0039AD39,$0031AD31,$0029A529,$0042AD4A,$004A944A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A31,$000000FF,$000000FF,$00428C39,$0031A531,$0039B531,$0031B539,$0029AD31,$00299C31,$0039A542,$0039AD42,$00319C29,$00298C29,$00298C29,$00319431,$0031A539,$0029AD31,$0021AD29,$0031AD31,$0039AD31,$0039A539,$0039AD39,$0031B531,$0039B539,$0039A539,$004AA54A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A9452,$00529C52,$006BA563,$000000FF,$000000FF,$00428C4A,$0042A542,$0031A531,$0031A531,$00299C29,$0042B54A,$0031A539,$0031AD29,$0029A529,$00299C31,$00319431,$00319431,$0031A539,$0021AD29,$0021B521,$0031B531,$0039AD31,$0039A539,$0039AD39,$0029A529,$0021A521,$0039B539,$00319431,$005A8C52,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$006B946B,$005A945A,$004AA54A,$00319431,$00529C4A,$000000FF,$000000FF,$00398442,$0042A54A,$0039A539,$0039A539,$0042B542,$00299429,$0031AD31,$0029A529,$0031AD31,$00219421,$00299431,$00319431,$0031A539,$0029AD29,$0021B521,$0031B531,$0039B531,$0039A539,$0039AD39,$0031B531,$0031B529,$0029A529,$004AAD39,$00528C4A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$0042944A,$0042A54A,$0039A542,$0042AD42,$0042AD42,$00429C42,$000000FF,$00186321,$00398C42,$00399442,$0042AD4A,$0039AD39,$0039AD39,$0031AD31,$0031AD31,$0039B539,$0031AD39,$00319C31,$00299431,$00319431,$0031A531,$0039AD31,$0039B531,$0031B531,$0031AD31,$0031AD39,$0031AD39,$0031B539,$0029A529,$0039AD29,$0042A531,$00529442,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00397B42,$004AA552,$0039AD42,$0031AD39,$0031AD31,$0031A531,$00319C31,$0042A54A,$000000FF,$00298431,$00318431,$00318C39,$00399C42,$0031A539,$0031AD31,$0031AD29,$0029AD29,$0031AD31,$0031A531,$00299C31,$00299431,$00299431,$00319C31,$0039A531,$0039AD31,$0031AD31,$0029AD31,$0029AD39,$0029AD39,$0021A529,$0039BD39,$0039AD29,$0039A529,$005AA542,$005A8C52,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$005AA552,$004AA542,$0039A539,$0039AD31,$0031B531,$0029A529,$0039B539,$0039AD39,$004AAD4A,$000000FF,$00399C42,$00319439,$00399C42,$0042AD4A,$0031A531,$0031AD31,$0031AD31,$0031AD29,$0031AD31,$0031A531,$00299C31,$00299431,$00299431,$00319431,$0039A531,$0039AD31,$0031AD29,$0029AD31,$0029A531,$0029AD39,$0029AD31,$0031AD31,$0039B529,$0042B529,$00429C31,$004A9442,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00397B42,$00529C4A,$00399C31,$0039A531,$0031A529,$0039B531,$00219C21,$0031AD31,$0031A529,$0039AD39,$00299C29,$0052BD52,$00298C29,$00298C31,$00319431,$0031A539,$0031AD31,$0031AD31,$0031B529,$0031B529,$0031B531,$0031AD31,$0031A531,$00319C31,$00298C31,$00319431,$0031A531,$0039AD31,$0039AD31,$0031AD31,$0029A531,$0029AD39,$0031B539,$0029AD29,$0029AD21,$0039B529,$0042AD31,$004AA542,$004A8C52,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A9C52,$004AAD4A,$0039A531,$0042B539,$0029A529,$0039B531,$0029A521,$0031AD31,$0039B539,$0031AD31,$0042B539,$00299C29,$0031A531,$00299431,$00319C31,$00319C31,$00299C29,$0031AD31,$0031AD29,$0029AD29,$0029AD29,$0031AD31,$0031AD31,$0031A531,$00299C31,$00298C31,$00319439,$00399C31,$0039AD31,$0039AD31,$0039AD31,$0031AD39,$0031AD39,$0029AD31,$0031B531,$0029AD29,$0031AD29,$0039AD31,$0039A539,$004AA552,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00216B29,$00429C42,$0039A539,$0031AD31,$0031AD31,$0031AD31,$0039B539,$0029A529,$0031A531,$0039AD39,$0039AD31,$0039AD31,$0031AD31,$0039A531,$0039AD39,$00299429,$00299429,$0031A531,$00299C29,$0039AD39,$0031AD31,$0031AD29,$0031AD31,$0031AD31,$0039AD39,$0039A539,$00319C31,$00318C39,$00319439,$00319C31,$0039A531,$0042AD31,$0039AD31,$0039AD39,$0031AD39,$0039AD42,$0029A531,$0031AD29,$0039BD39,$0031AD29,$0031A531,$00399C42,$00216B29,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$00529C4A,$0052AD4A,$0031A529,$0039B539,$0029AD31,$0031B539,$0031AD39,$0039AD42,$0039AD42,$00299C31,$0042AD42,$00399C31,$0042AD42,$0031A531,$0039AD39,$0042B542,$00299429,$00219421,$00319C31,$00319C31,$0039AD39,$0039AD31,$0039AD31,$0039AD39,$0039AD39,$0042AD42,$0042AD42,$00399C39,$00319439,$00319439,$00319C31,$00399C29,$0039A531,$0039A531,$0039A539,$0039A542,$0039A542,$00299C31,$0029A529,$0031AD31,$0031AD31,$0039AD42,$0039A542,$0052A55A,$000000FF,$000000FF,
												   $000000FF,$000000FF,$00638C5A,$00528C4A,$0052A542,$00399C29,$004ABD42,$0031A531,$0031AD39,$0031AD39,$00299C39,$00299C39,$0039A542,$0042A54A,$0042A542,$0042A542,$00399C39,$0039A539,$0042A542,$0042AD42,$00319C31,$00299429,$00299429,$00319C31,$0039A539,$0039A539,$0039A539,$0039A539,$0039A539,$0042A542,$0042A542,$00399C39,$00319439,$00319439,$00319431,$00319C29,$00399C31,$0042A531,$0042A542,$0042A542,$0042A54A,$0039A542,$0042B54A,$00299C31,$0039A539,$0039A539,$0039A539,$004A944A,$000000FF,$000000FF,
												   $000000FF,$0052844A,$00528C4A,$0063A55A,$00429442,$0052A552,$00399439,$0042A54A,$0039A542,$0039A542,$00399C42,$00429C42,$00429C4A,$00429C42,$004AA54A,$004AA54A,$00429C42,$004AA54A,$0042A542,$004AAD4A,$0042A542,$00399C39,$00319431,$00319439,$0042A542,$00429C42,$00429C42,$0042A54A,$00429C4A,$004AA54A,$004AA54A,$0042A54A,$00298C31,$00298C31,$00399C39,$00319429,$004AA539,$00429C39,$004AA54A,$00429442,$00429C4A,$00399442,$004AA54A,$00429C42,$0042A542,$0042A542,$00399C42,$00529C52,$00528452,$000000FF,
												   $00316B21,$00397331,$00317331,$00215A21,$00297331,$00216B29,$00217329,$00186B21,$00217329,$00187321,$00217321,$00217B21,$00297B29,$00217318,$00106310,$00217321,$00217329,$00297329,$00187321,$00187318,$00217321,$00298429,$00318C31,$00399439,$00217321,$00187321,$00217321,$00217329,$00217321,$00217321,$00217321,$00217321,$00399C42,$00319C39,$00319431,$00318C29,$00217B18,$00217318,$00217321,$00297329,$00216B29,$00297B31,$00217329,$00186B21,$00217321,$00186318,$00317B31,$00216321,$00426B42,$000000FF,
												   $000000FF,$00295A29,$00316331,$00296331,$00396B42,$00296331,$00296331,$00317339,$00216321,$00296B21,$00317B29,$00216B18,$00216B21,$00297329,$00216B21,$00296B29,$00296B29,$00297331,$00216B29,$00216B21,$00297B29,$00398C39,$00429442,$00398C39,$00216B21,$00216B21,$00296B29,$00296B31,$00296B29,$00216B29,$00216B21,$00217321,$00319439,$00299431,$00298C29,$00399439,$00217318,$00216B21,$00216321,$00296B29,$00296329,$00317331,$00216321,$00296B29,$00296B31,$00296B29,$00296329,$00316331,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$00315A39,$00395A42,$00426B4A,$00315A31,$00396B39,$00396B39,$00397331,$00397329,$00296B21,$00216321,$00317329,$00397B31,$00296B29,$00296329,$00316B31,$00296B31,$00216B21,$00318431,$00398C39,$00398C39,$00318431,$00296B29,$00296B31,$00296B31,$00316B39,$00316B31,$00296B29,$00296B29,$00297B29,$00399439,$00319431,$00318C31,$00429442,$00297329,$00317331,$00316B31,$00296329,$00316B31,$00316B31,$00316B31,$00316B31,$00295A29,$00316331,$00396339,$004A6B4A,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$00395A42,$00395A39,$00426339,$00315A29,$00396331,$00316329,$00296321,$00397339,$00396B31,$00215A21,$00316B31,$00316B31,$00316339,$00316331,$00316B31,$00296B29,$00428C39,$00428C39,$00429442,$00428C42,$00216B29,$00296B29,$00296331,$00296331,$00296331,$00216329,$00296B29,$00317B31,$00429C39,$00399431,$00429439,$00297329,$00296329,$00296329,$00396B39,$00296329,$00396B31,$00316331,$00316331,$00316331,$00396331,$00315A31,$00395A39,$00315239,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00425A39,$00395A31,$00426339,$00426B39,$00315A29,$00295A29,$00396B39,$00316B31,$00316331,$00316331,$00316339,$00295A29,$00316B31,$00296B21,$00428C42,$00398C39,$00428C39,$00398439,$00296B31,$00316B39,$00316B39,$00316339,$00316B31,$00296B29,$00317331,$00428C39,$00399431,$00399431,$00429442,$00296B29,$00316331,$00295A31,$00426B42,$00316331,$00316331,$00316B31,$00316329,$00396331,$00315A31,$004A6B4A,$00426342,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A39,$00295231,$00426B4A,$00396B42,$00316339,$00396B39,$00316339,$00427342,$00396339,$00316331,$00397339,$00296B29,$004A9442,$00398C39,$00398C39,$00297321,$00296B29,$00316B31,$00296331,$00316331,$00316331,$00296329,$00317329,$00428C39,$00399431,$00429439,$00428C42,$00317339,$00316B39,$00316339,$00316339,$00396339,$00295A29,$00316329,$00316329,$00427339,$00315A31,$00395A39,$00395A42,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00315239,$00396342,$00315A39,$00426B42,$00295A29,$00396339,$00396339,$00316331,$00396B31,$00215A18,$00428C42,$00428C39,$00428C39,$00216B21,$00296B29,$00316B31,$00316331,$00316331,$00316B31,$00296B29,$00317B29,$00429442,$00398C31,$00428C39,$00216B21,$00296329,$00295A31,$00396342,$00315A31,$00396B39,$00396B31,$00316B31,$00316B31,$00295A29,$00426342,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00395A42,$00395A42,$00396342,$00316339,$00316331,$00316331,$00397339,$000000FF,$00397B42,$00428442,$004A8C42,$00296B21,$00317329,$00316B31,$00316B31,$00296331,$00296B31,$00297329,$00398C39,$00429439,$00398C39,$00429442,$00296B29,$00296329,$00316B39,$00316331,$00316331,$00316B31,$00316B31,$00296329,$00396B39,$00315A31,$00395A39,$00425A42,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$0042634A,$00395A42,$00426342,$00395A39,$00396331,$00396B31,$00316331,$000000FF,$004A8452,$00528C4A,$00428442,$00316B29,$00316B29,$00397B39,$00296329,$00316B31,$00296B31,$00297329,$00318431,$00429442,$00398C39,$00398439,$00296B29,$00296B29,$00316B31,$00316331,$00316B31,$00316B31,$00296329,$00296331,$00296331,$00396B39,$00426342,$00425239,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A42,$00426342,$00396339,$00426B39,$00315A31,$000000FF,$000000FF,$00427342,$00316B31,$00316B29,$00397331,$00296B29,$00296329,$00317339,$00317B31,$00216B21,$00429439,$00398C39,$00428C42,$00297329,$00296B29,$00316B31,$00296329,$00316B31,$00396B39,$00316B31,$00316B39,$00316B31,$00396B39,$00396339,$00395A39,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426342,$00395A39,$00426342,$00395A39,$000000FF,$000000FF,$00528452,$00316329,$00316B31,$00316329,$00316B29,$00296329,$00296B31,$00216B29,$00398C42,$00429442,$00298429,$00428C42,$00216B21,$00316B31,$00316B31,$00296329,$00396B39,$00316B31,$00316B31,$00316331,$00316B31,$00316339,$00396339,$00395A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395239,$004A634A,$000000FF,$000000FF,$004A7B52,$00396339,$00316B31,$00396B31,$00316B31,$00316B39,$00185A21,$00317331,$00398C42,$00398C31,$00429C42,$00398439,$00296B29,$00296B29,$00296B29,$00316B31,$00316B31,$00296329,$00316B31,$00397339,$00316331,$00315A31,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$005A7B5A,$00426339,$00396331,$00396B31,$00296329,$00397339,$00316B31,$00297331,$00398C42,$00398C39,$00398C39,$00317331,$00296B29,$00296B29,$00296329,$00316B31,$00316331,$00295A29,$00316331,$00316331,$00396339,$00315A39,$00395A39,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00426339,$00426339,$00396331,$00427342,$00215A29,$00296331,$00216329,$004A9452,$00429C42,$00318431,$00296B29,$00317331,$00296329,$00316329,$00316B31,$00296329,$00316331,$00316331,$00396B39,$00315A31,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426342,$00426339,$004A6B42,$00396339,$00396339,$00397342,$000000FF,$00398442,$00398C39,$00428C42,$00296B29,$00397331,$00316329,$00316B31,$00316B31,$00296329,$00396B39,$00316331,$00316339,$00396339,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00425A39,$00395A31,$00426342,$00396339,$000000FF,$00428442,$004A944A,$00398431,$00397331,$00316329,$00316B31,$00316329,$00316B31,$00316331,$00396B39,$00396B39,$00396342,$00426342,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A6B4A,$00425A42,$00395A39,$000000FF,$00316331,$00397B39,$00317331,$00296329,$00396B39,$00396B39,$00295A29,$00296329,$00316B31,$00396B39,$00315A31,$00426342,$00395A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00394A39,$000000FF,$000000FF,$000000FF,$005A8C52,$00316329,$00316331,$00396339,$00316331,$00396B39,$00316331,$00316331,$00316339,$00396B42,$00396339,$00425A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426B42,$00396331,$00426339,$00396339,$00295A29,$00396B39,$00396B39,$00396B39,$00316331,$00396339,$00395A39,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00425A42,$00426342,$00426342,$00395A39,$00396339,$00396B39,$00296329,$00316B39,$00396B39,$00396339,$00425A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426342,$00395A39,$00427342,$00315A31,$00316B39,$00316331,$00295A29,$00426B42,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00315231,$00395A39,$00316331,$00316331,$00295A29,$00396B39,$00315A31,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A39,$00315A39,$00396B42,$00315A39,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00425A42,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00526352,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF);


procedure Register;
begin
	RegisterComponentEditor(TARERegistryVariable, TDialogComponent);
	RegisterComponents('AR_Albert Research[0]', [TARERegistryVariable]);
	RegisterPropertyEditor(TypeInfo(TAboutProperty), TARERegistryVariable, 'Author', TAboutProperty);
end;

{ TARERegistryVariable }

constructor TARERegistryVariable.Create(AOwner: TComponent);
begin
	inherited Create(AOwner);

	V_RootRegistryKey := rgk_HKEY_CURRENT_USER;
	V_VariableName := '';
	V_VariableType := rvt_String;
	V_WriteOnDef := True;
	V_RegistryKeys := TRegistryKeys.Create(Self);
end;

destructor TARERegistryVariable.Destroy;
begin
	V_RegistryKeys.Free;
	inherited Destroy;
end;

procedure TARERegistryVariable.Loaded;
begin
	inherited Loaded;
end;

procedure TARERegistryVariable.PSetV_RegistryKeys(const Value: TRegistryKeys);
begin
	V_REgistryKeys.Assign(Value);
end;

procedure TARERegistryVariable.PSetV_RootRegistryKey(const Value: TRootRegistryKey);
begin
	if Value <> V_RootRegistryKey then
		begin
			V_RootRegistryKey := Value;
		end;
end;


procedure TARERegistryVariable.PSetV_VariableName(const Value: string);
begin
	if Value <> V_VariableName then
		begin
			V_VariableName := Value;
		end;
end;

procedure TARERegistryVariable.PSetV_VariableType(const Value: TVariableType);
begin
	if Value <> V_VariableType then
		begin
			V_VariableType := Value;
		end;
end;

procedure TARERegistryVariable.PSetV_WriteOnDef(const Value: boolean);
begin
	if Value <> V_WriteOnDef then
		begin
			V_WriteOnDef := Value;
		end;
end;

procedure TARERegistryVariable.DeleteKeyatRegistry(Index: integer);
var
	NumeroItem				: integer;
	Reg						: TRegistry;
	DeleteKeyError			: boolean;
begin
	{if there is no Keys defined then exist silently}
	if V_RegistryKeys.Count = 0 then
		exit;

	{if the index passed is lower than the bounds of the Keys then exit silently}
	if (Index < 0 ) OR (Index > V_RegistryKeys.Count) then
		exit;

	if (Index = 0) AND (UpperCase(V_RegistryKeys.Items[0].RegistryKey) = 'SOFTWARE') then
		begin
			Messagebeep(2);
			MessageDlg('For Security Reasons Deleting a Key with Index 0 and Name (Software) is Disabled',mtWarning,[mbOk],0);
			exit;
		end;

	if (Index = 0) AND (UpperCase(V_RegistryKeys.Items[0].RegistryKey) = 'HARDWARE') then
		begin
			Messagebeep(2);
			MessageDlg('For Security Reasons Deleting a Key with Index 0 and Name (Hardware) is Disabled',mtWarning,[mbOk],0);
			exit;
		end;

	if (Index = 0) AND (UpperCase(V_RegistryKeys.Items[0].RegistryKey) = 'SYSTEM') then
		begin
			Messagebeep(2);
			MessageDlg('For Security Reasons Deleting a Key with Index 0 and Name (System) is Disabled',mtWarning,[mbOk],0);
			exit;
		end;

	if (Index = 0) AND (UpperCase(V_RegistryKeys.Items[0].RegistryKey) = 'CLONE') then
		begin
			Messagebeep(2);
			MessageDlg('For Security Reasons Deleting a Key with Index 0 and Name (Clone) is Disabled',mtWarning,[mbOk],0);
			exit;
		end;


	Reg := TRegistry.Create;

	{Assigning the RootKey}
	case V_RootRegistryKey of
		rgk_HKEY_CLASSES_ROOT: Reg.RootKey := HKEY_CLASSES_ROOT;
		rgk_HKEY_CURRENT_USER: Reg.RootKey := HKEY_CURRENT_USER;
		rgk_HKEY_LOCAL_MACHINE: Reg.RootKey := HKEY_LOCAL_MACHINE;
		rgk_HKEY_CURRENT_CONFIG: Reg.RootKey := HKEY_CURRENT_CONFIG;
	end;

	DeleteKeyError := False;
	NumeroItem := 0;

	{Searching for the requested key until the index is reached... 0 index means the first key so there is no need to open it}
	if Index > 0 then
		begin
			repeat
				{if key could not be opened then inform that there was an error}
				if not Reg.OpenKey(V_RegistryKeys.Items[NumeroItem].RegistryKey,False) then
					begin
						DeleteKeyError := True;
						break;
					end;
				inc(NumeroItem);
			until NumeroItem = Index;
		end;


	case DeleteKeyError of
		True:
			begin
				MessageDlg(Format('Key of Index : %d [%s] not found.',[Index,V_RegistryKeys.Items[Index].RegistryKey]),mtError,[mbOk],0);
			end;
		False:
			begin
				case MessageDlg(Format('WARNING !!! You are going to delete Key Name : [%s].'+#13#10+'Depending on what key it is, this may Damage your system or make it Unestable. Are You Sure to delete the Key.',[V_RegistryKeys.Items[Index].RegistryKey]),mtWarning,[mbYes,mbNo],0) of
					mrYes:
						begin
							case MessageDlg(Format('Sorry to be Repetitive. Area You Sure to delete the Key.',[V_RegistryKeys.Items[Index].RegistryKey]),mtWarning,[mbYes,mbNo],0) of
								mrYes:
									begin
										if Reg.DeleteKey(V_RegistryKeys.Items[Index].RegistryKey) then
											begin
												MessageDlg(Format('Key [%s] Successfully deleted.',[V_RegistryKeys.Items[Index].RegistryKey]),mtInformation,[mbOk],0);
											end
										else
											begin
												MessageDlg(Format('Could not Delete Key [%s].',[V_RegistryKeys.Items[Index].RegistryKey]),mtError,[mbOk],0);
											end;
									end;
								mrNo:
									begin
										MessageBeep(1);
									end;
							end;
						end;
					mrNo:
						begin
							MessageBeep(1);
						end;
				end;
			end;
	end;
end;

procedure TARERegistryVariable.DeleteVariable;
var
	NumeroItem				: integer;
	Reg						: TRegistry;
	DeleteError				: boolean;
	ErrorType				: TARERegistryErrorType;
	Param					: string;

begin
	if V_RegistryKeys.Count = 0 then
		exit;

	Reg := TRegistry.Create;

	case V_RootRegistryKey of
		rgk_HKEY_CLASSES_ROOT: Reg.RootKey := HKEY_CLASSES_ROOT;
		rgk_HKEY_CURRENT_USER: Reg.RootKey := HKEY_CURRENT_USER;
		rgk_HKEY_LOCAL_MACHINE: Reg.RootKey := HKEY_LOCAL_MACHINE;
		rgk_HKEY_CURRENT_CONFIG: Reg.RootKey := HKEY_CURRENT_CONFIG;
	end;

	DeleteError := False;
	NumeroItem := 0;
	Param := '';
	ErrorType := AR_ErrorNone;

	repeat
		if not Reg.OpenKey(V_RegistryKeys.Items[NumeroItem].RegistryKey,False) then
			begin
				DeleteError := True;
				Param := V_RegistryKeys.Items[NumeroItem].RegistryKey;
				ErrorType := ERR_Delete_KeyNotFound;
				break;
			end;
		inc(NumeroItem);
	until NumeroItem = V_RegistryKeys.Count;

	case DeleteError of
		True:
			begin
				if (csDesigning in ComponentState) then
					begin
						ShowMessage(Format('Value : %s not Deleted. Value Does not exist at Registry.',[V_VariableName]));
						exit;
					end;
			end;
		False:
			begin
				if Reg.ValueExists(V_VariableName) then
					begin
						if (csDesigning in ComponentState) then
							begin
								case MessageDlg(Format('Are you sure to Delete the Registry Value : (%s) for current Key Path.',[V_VariableName]),mtWarning,[mbYes,mbNo],0) of
									mrYes:
										begin
											if Reg.DeleteValue(V_VariableName) then
												begin
													MessageDlg('Registry Value Successfully Deleted.',mtInformation,[mbOk],0);
												end
											else
												begin
													MessageDlg('Registry Value Could not be Deleted.',mtError,[mbOk],0);
												end;
										end;
									mrNo:
										begin
											MessageBeep(1);
										end;
								end;

								exit;
							end
						else
							begin
								Reg.DeleteValue(V_VariableName);
							end;
					end
				else
					begin
						ErrorType := ERR_Delete_ValueNotFound;
						Param := V_VariableName;
						DeleteError := True;
					end;
		end;
	end;

	if DeleteError then
		begin
			if Assigned(V_ErrorNotify) then
				begin
					V_ErrorNotify(Self,ErrorType,Param);
				end;
		end;

end;

function TARERegistryVariable.Read:Variant;
var
	NumeroItem				: integer;
	Reg						: TRegistry;
	ReadError				: boolean;
	ErrorType				: TARERegistryErrorType;
	Param					: string;
begin
	if V_RegistryKeys.Count = 0 then
		exit;

	Reg := TRegistry.Create;

	case V_RootRegistryKey of
		rgk_HKEY_CLASSES_ROOT: Reg.RootKey := HKEY_CLASSES_ROOT;
		rgk_HKEY_CURRENT_USER: Reg.RootKey := HKEY_CURRENT_USER;
		rgk_HKEY_LOCAL_MACHINE: Reg.RootKey := HKEY_LOCAL_MACHINE;
		rgk_HKEY_CURRENT_CONFIG: Reg.RootKey := HKEY_CURRENT_CONFIG;
	end;

	ReadError := False;
	NumeroItem := 0;
	Param := '';
	ErrorType := AR_ErrorNone;

	repeat
		if not Reg.OpenKey(V_RegistryKeys.Items[NumeroItem].RegistryKey,V_RegistryKeys.Items[NumeroItem].CreateKey) then
			begin
				ReadError := True;
				Param := V_RegistryKeys.Items[NumeroItem].RegistryKey;
				ErrorType := ERR_Read_KeyNotFound;
				break;
			end;
		inc(NumeroItem);
	until NumeroItem = V_RegistryKeys.Count;

	case ReadError of
		True:
			begin
				Read := Null;
			end;
		False:
			begin
				if Reg.ValueExists(V_VariableName) then
					begin
						case V_VariableType  of
							rvt_Bool		: Read := Reg.ReadBool(V_VariableName);
							rvt_Currency	: Read := Reg.ReadCurrency(V_VariableName);
							rvt_Date		: Read := Reg.ReadDate(V_VariableName);
							rvt_DateTime	: Read := Reg.ReadDateTime(V_VariableName);
							rvt_Time		: Read := Reg.ReadTime(V_VariableName);
							rvt_Float		: Read := Reg.ReadFloat(V_VariableName);
							rvt_Integer		: Read := Reg.ReadInteger(V_VariableName);
							rvt_String		: Read := Reg.ReadString(V_VariableName);
						end;
					end
				else
					begin
						ErrorType := ERR_Read_ValueNotFound;
						Param := V_VariableName;
						ReadError := True;
					end;
		end;
	end;

	if ReadError then
		begin
			if Assigned(V_ErrorNotify) then
				begin
					V_ErrorNotify(Self,ErrorType,Param);
				end;
		end;

end;

function TARERegistryVariable.ReadDef(DefaultRead: Variant): Variant;
var
	NumeroItem				: integer;
	Reg						: TRegistry;
	ReadError				: boolean;
begin
	if V_RegistryKeys.Count = 0 then
		exit;

	Reg := TRegistry.Create;

	case V_RootRegistryKey of
		rgk_HKEY_CLASSES_ROOT: Reg.RootKey := HKEY_CLASSES_ROOT;
		rgk_HKEY_CURRENT_USER: Reg.RootKey := HKEY_CURRENT_USER;
		rgk_HKEY_LOCAL_MACHINE: Reg.RootKey := HKEY_LOCAL_MACHINE;
		rgk_HKEY_CURRENT_CONFIG: Reg.RootKey := HKEY_CURRENT_CONFIG;
	end;

	ReadError := False;
	NumeroItem := 0;

	repeat
		if not Reg.OpenKey(V_RegistryKeys.Items[NumeroItem].RegistryKey,V_RegistryKeys.Items[NumeroItem].CreateKey) then
			begin
				ReadError := True;
				break;
			end;
		inc(NumeroItem);
	until NumeroItem = V_RegistryKeys.Count;

	case ReadError of
		True:
			begin
				ReadDef := Null;
			end;
		False:
			begin
				if Reg.ValueExists(V_VariableName) then
					begin
						case V_VariableType  of
							rvt_Bool		: ReadDef := Reg.ReadBool(V_VariableName);
							rvt_Currency	: ReadDef := Reg.ReadCurrency(V_VariableName);
							rvt_Date		: ReadDef := Reg.ReadDate(V_VariableName);
							rvt_DateTime	: ReadDef := Reg.ReadDateTime(V_VariableName);
							rvt_Time		: ReadDef := Reg.ReadTime(V_VariableName);
							rvt_Float		: ReadDef := Reg.ReadFloat(V_VariableName);
							rvt_Integer		: ReadDef := Reg.ReadInteger(V_VariableName);
							rvt_String		: ReadDef := Reg.ReadString(V_VariableName);
						end;
					end
				else
					begin
						ReadError := True;
					end;
		end;
	end;

	if ReadError then
		begin
			if V_WriteOnDef then
				begin
					Write(DefaultRead);
				end;

			ReadDef := DefaultRead;
		end;

end;

procedure TARERegistryVariable.Write(Value: Variant);
var
	NumeroItem				: integer;
	Reg						: TRegistry;
	WriteError				: boolean;
	ErrorType				: TARERegistryErrorType;
	Param					: string;
begin
	if V_RegistryKeys.Count = 0 then
		exit;

	Reg := TRegistry.Create;

	case V_RootRegistryKey of
		rgk_HKEY_CLASSES_ROOT: Reg.RootKey := HKEY_CLASSES_ROOT;
		rgk_HKEY_CURRENT_USER: Reg.RootKey := HKEY_CURRENT_USER;
		rgk_HKEY_LOCAL_MACHINE: Reg.RootKey := HKEY_LOCAL_MACHINE;
		rgk_HKEY_CURRENT_CONFIG: Reg.RootKey := HKEY_CURRENT_CONFIG;
	end;

	WriteError := False;
	NumeroItem := 0;
	Param := '';
	ErrorType := AR_ErrorNone;

	repeat
		if not Reg.OpenKey(V_RegistryKeys.Items[NumeroItem].RegistryKey,True) then
			begin
				WriteError := True;
				Param := V_RegistryKeys.Items[NumeroItem].RegistryKey;
				ErrorType := ERR_Write_KeyNotFound;
				break;
			end;
		inc(NumeroItem);
	until NumeroItem = V_RegistryKeys.Count;

	if not WriteError then
		begin
			case V_VariableType  of
				rvt_Bool:
					begin
						try
							Reg.WriteBool(V_VariableName,Value);
						except
							WriteError := True;
						end;
					end;
				rvt_Currency:
					begin
						try
							Reg.WriteCurrency(V_VariableName,Value);
						except
							WriteError := True;
						end;
					end;
				rvt_Date:
					begin
						try
							Reg.WriteDate(V_VariableName,Value);
						except
							WriteError := True;
						end;
					end;
				rvt_DateTime:
					begin
						try
							Reg.WriteDateTime(V_VariableName,Value);
						except
							WriteError := True;
						end;
					end;
				rvt_Time:
					begin
						try
							Reg.WriteTime(V_VariableName,Value);
						except
							WriteError := True;
						end;
					end;
				rvt_Float:
					begin
						try
							Reg.WriteFloat(V_VariableName,Value);
						except
							WriteError := True;
						end;
					end;
				rvt_Integer:
					begin
						try
							Reg.WriteInteger(V_VariableName,Value);
						except
							WriteError := True;
						end;
					end;
				rvt_String:
					begin
						try
							Reg.WriteString(V_VariableName,Value);
						except
							WriteError := True;
						end;
					end;
			end;

			if WriteError then
				begin
					Param := V_VariableName;
					ErrorType := ERR_Write_Value;
				end;
		end;

	if WriteError then
		begin
			if Assigned(V_ErrorNotify) then
				begin
					V_ErrorNotify(Self,ErrorType,Param);
				end;
		end;

end;


procedure TARERegistryVariable.Copyright;
var
	VForm				: TForm;
	VButton				: TButton;
	VLabel				: TLabel;
	VLabel1				: TARUrlLabel;
	VLabel2				: TARUrlLabel;
	VImage				: TImage;

	Counter				: integer;
	X,Y					: integer;
begin
	VForm := TForm.Create(nil);
	VButton := TButton.Create(VForm);
	VLabel := TLabel.Create(VForm);
	VLabel1 := TARUrlLabel.Create(VForm);
	VLabel2 := TARUrlLabel.Create(VForm);
	VImage := TImage.Create(VForm);

	VButton.Width := 60;
	VButton.Height := 21;
	VButton.Left := 126;
	VButton.Top := 120;
	VButton.Caption := 'Ok';
	VButton.ModalResult := mrOk;
	Vbutton.Parent := VForm;

	VLabel.Width := 252;
	VLabel.Height := 205;
	VLabel.Left := 64;
	VLabel.Top := 4;
	VLabel.AutoSize := False;
	VLabel.Caption := 'ARERegistryVariable. An Enhanced ARRegistryVaria-'+#10
					 +'ble Object. Now you can Store you Variables at any'+#10
					 +'Place at the Registry.'+#10#10+'E-Mail:'+#10#10+'WWW:';
	VLabel1.Left := 100;
	VLabel1.Top := 56;

	VLabel2.Left := 100;
	VLabel2.Top := 82;

	VLabel1.Url := 'albertrs@redestb.es';
	VLabel1.Caption := 'albertrs@redestb.es';
	VLabel1.UrlType := url_mailto;

	VLabel2.Url := 'http://personal.redestb.es/albertrs';
	VLabel2.Caption := 'http://personal.redestb.es/albertrs';
	VLabel2.URLType := url_http;

	VLabel.Parent := VForm;
	VLabel1.Parent := VForm;
	VLabel2.Parent := VForm;
	VImage.Parent := VForm;
	VImage.Transparent := True;

	VImage.Top := 10;
	VImage.Left := 10;

	Counter := 1;
	VImage.Picture.BitMap.Height := V_AlbertResearchHeight;
	VImage.Picture.BitMap.Width := V_AlbertResearchWidth;	

	for x := 0 to VImage.Picture.BitMap.Width - 1 do
		begin
			for y := 0 to VImage.Picture.BitMap.Height - 1 do
				begin
					VImage.Picture.BitMap.Canvas.Pixels[x,y] := V_AlbertResearch[Counter];
					inc(Counter);
				end;
		end;


	VForm.BorderStyle := bsToolWindow;
	VForm.Width := 324;
	VForm.Height := 170;
	VForm.Position := poScreenCenter;
	VForm.Caption := 'Albert Research 98 ARERegistryVariable V1.0';
	VForm.ShowModal;

end;


function TARERegistryVariable.V_KeyCount: integer;
begin
	V_KeyCount := V_RegistryKeys.Count;
end;

procedure TARERegistryVariable.AR_BTNOkClick(Sender: TObject);
begin
	V_Form.Close;
end;

procedure TARERegistryVariable.AR_RBTClick(Sender: TObject);
begin
	if not V_PAN_Form.Showing then
		exit;

	if V_RBT_VariableType[8].Checked then
		begin
			V_Node.ImageIndex := 2;
			V_Node.SelectedIndex := 2;
		end
	else
		begin
			V_Node.ImageIndex := 1;
			V_Node.SelectedIndex := 1;
		end;

	V_TRV_Registry.Invalidate;
end;

procedure TARERegistryVariable.AR_FormCloseImportFile(Sender: TObject; var Action: TCloseAction);
var
	NumeroItem				: integer;
begin
	NumeroItem := 1;
	repeat
		if V_RBT_VariableType[NumeroItem].Checked then
			begin
				case NumeroItem of
					1: VariableType := rvt_Bool;
					2: VariableType := rvt_Currency;
					3: VariableType := rvt_Date;
					4: VariableType := rvt_DateTime;
					5: VariableType := rvt_Time;
					6: VariableType := rvt_Float;
					7: VariableType := rvt_Integer;
					8: VariableType := rvt_String;
				end;
			end;
		inc(NumeroItem);
	until NumeroItem = High(V_RBT_VariableType) + 1;

	Action := caFree;

end;


procedure TARERegistryVariable.ImportFile(V_KeyString, V_ValueString: string);
var
	V_RootKey				: TRootRegistryKey;
	V_RootKeyInterpreted	: boolean;
	V_Keys					: array[1..100] of string;
	V_KeysCount				: integer;
	V_ReadPos				: integer;
	V_Key					: string;
	V_ValueName				: string;
	V_RegistryKey			: TRegistryKey;
	V_NodeStore				: TTreeNode;

	V_BitMap				: TBitMap;
	Counter					: integer;
	X,Y						: integer;

	NumeroItem				: integer;

begin
	{Reading the Keys}
	V_KeysCount := 0;
	V_ReadPos := 1;
	V_Key := '';

	repeat
		case V_KeyString[V_ReadPos] of
			'[': inc(V_ReadPos);
			'\':
				begin
					inc(V_KeysCount);
					V_Keys[V_KeysCount] := V_Key;
					V_Key := '';
					inc(V_ReadPos);
				end;
			']':
				begin
					inc(V_KeysCount);
					V_Keys[V_KeysCount] := V_Key;
					break;
				end;
			else
				begin
					V_Key := V_Key + V_KeyString[V_ReadPos];
					inc(V_ReadPos);
				end;
		end;
		if V_KeyCount = 100 then
			begin
				MessageDlg('The Range of accepted Keys in the subtree is 100. This file has more than this amount. Exiting Importation',mtError,[mbOk],0);
				exit;
			end;
	until V_ReadPos > Length(V_KeyString);



	V_RootKey := rgk_HKEY_CURRENT_USER;
	V_RootKeyInterpreted := False;

	if UpperCase(V_Keys[1]) = 'HKEY_CLASSES_ROOT' then
		begin
			V_RootKey := rgk_HKEY_CLASSES_ROOT;
			V_RootKeyInterpreted := True;
		end;

	if UpperCase(V_Keys[1]) = 'HKEY_CURRENT_USER' then
		begin
			V_RootKey := rgk_HKEY_CURRENT_USER;
			V_RootKeyInterpreted := True;
		end;

	if UpperCase(V_Keys[1]) = 'HKEY_LOCAL_MACHINE' then
		begin
			V_RootKey := rgk_HKEY_LOCAL_MACHINE;
			V_RootKeyInterpreted := True;
		end;

	if UpperCase(V_Keys[1]) = 'HKEY_CURRENT_CONFIG' then
		begin
			V_RootKey := rgk_HKEY_CURRENT_CONFIG;
			V_RootKeyInterpreted := True;
		end;


	if not V_RootKeyInterpreted then
		begin
			MessageDlg('A Minor problem Ocurred while Interpreting the RootKey. The RootKey is not one of the Four Allowed. It will be HKEY_CURRENT_USER Applied.',mtInformation,[mbOk],0);
		end;


	{Reading the Value}
	if V_ValueString[1] = '@' then
		begin
			V_ValueName := '';
		end
	else
		begin
			V_ValueName := Copy(V_ValueString,1,Pos('=',V_ValueString) - 1);
			V_ValueName := Copy(V_ValueName,2,Length(V_ValueName) - 2);
		end;

	if V_RegistryKeys.Count > 0 then
		begin
			repeat
				V_RegistryKeys.Items[0].Free;
			until V_RegistryKeys.Count = 0;
		end;

	if V_KeysCount > 1 then
		begin
			for NumeroItem := 2 to V_KeysCount do
				begin
					V_RegistryKey := V_RegistryKeys.Add;
					V_RegistryKey.RegistryKey := V_Keys[NumeroItem];
					V_RegistryKey.CreateKey := True;
				end;
		end;

	VariableName := V_ValueName;
	RootKey := V_RootKey;

	{Creating the Form}
	V_Form := TForm.Create(Nil);
	V_Form.BorderStyle := bsNone;
	V_Form.Caption := 'Select Variable Type';
	V_Form.Position := poScreenCenter;
	V_Form.Width := 251;
	V_Form.Height := 307;
	V_Form.OnClose := AR_FormCloseImportFile;

	{Creating Panel}
	V_PAN_Form := TPanel.Create(V_Form);
	V_PAN_Form.Parent := V_Form;
	V_PAN_Form.Caption := '';
	V_PAN_Form.Align := alClient;
	V_PAN_Form.BevelWidth := 3;

	{Label}
	V_LAB_Text := TLabel.Create(V_PAN_Form);
	V_LAB_Text.Parent := V_PAN_Form;
	V_LAB_Text.Left := 8;
	V_LAB_Text.Top := 136;
	V_LAB_Text.Caption := 'Set Variable Type';

	{Button}
	V_BTN_Ok := TButton.Create(V_PAN_Form);
	V_BTN_Ok.Parent := V_PAN_Form;
	V_BTN_Ok.Left := 89;
	V_BTN_Ok.Top := 264;
	V_BTN_Ok.Width := 75;
	V_BTN_Ok.Height := 25;
	V_BTN_Ok.Caption := 'Ok';
	V_BTN_Ok.Default := True;
	V_BTN_Ok.TabOrder := 0;
	V_BTN_Ok.OnClick := AR_BTNOkClick;

	{Radio Buttons}
	For NumeroItem := 1 to 8 do
		begin
			V_RBT_VariableType[NumeroItem] := TRadioButton.Create(V_PAN_Form);
			V_RBT_VariableType[NumeroItem].Parent := V_PAN_Form;
			V_RBT_VariableType[NumeroItem].Width := 113;
			V_RBT_VariableType[NumeroItem].Height := 17;
			V_RBT_VariableType[NumeroItem].TabOrder := NumeroItem;
			V_RBT_VariableType[NumeroItem].OnClick := AR_RBTClick;


			case NumeroItem of
				1:
					begin
						V_RBT_VariableType[NumeroItem].Left := 12;
						V_RBT_VariableType[NumeroItem].Top := 159;
						V_RBT_VariableType[NumeroItem].Caption := 'rvt_Bool';
					end;
				2:
					begin
						V_RBT_VariableType[NumeroItem].Left := 12;
						V_RBT_VariableType[NumeroItem].Top := 179;
						V_RBT_VariableType[NumeroItem].Caption := 'rvt_Currency';
					end;
				3:
					begin
						V_RBT_VariableType[NumeroItem].Left := 12;
						V_RBT_VariableType[NumeroItem].Top := 199;
						V_RBT_VariableType[NumeroItem].Caption := 'rvt_Date';
					end;
				4:
					begin
						V_RBT_VariableType[NumeroItem].Left := 12;
						V_RBT_VariableType[NumeroItem].Top := 219;
						V_RBT_VariableType[NumeroItem].Caption := 'rvt_DateTime';
					end;
				5:
					begin
						V_RBT_VariableType[NumeroItem].Left := 128;
						V_RBT_VariableType[NumeroItem].Top := 159;
						V_RBT_VariableType[NumeroItem].Caption := 'rvt_Time';
					end;
				6:
					begin
						V_RBT_VariableType[NumeroItem].Left := 128;
						V_RBT_VariableType[NumeroItem].Top := 179;
						V_RBT_VariableType[NumeroItem].Caption := 'rvt_Float';
					end;
				7:
					begin
						V_RBT_VariableType[NumeroItem].Left := 128;
						V_RBT_VariableType[NumeroItem].Top := 199;
						V_RBT_VariableType[NumeroItem].Caption := 'rvt_Integer';
					end;
				8:
					begin
						V_RBT_VariableType[NumeroItem].Left := 128;
						V_RBT_VariableType[NumeroItem].Top := 219;
						V_RBT_VariableType[NumeroItem].Caption := 'rvt_String';
						V_RBT_VariableType[NumeroItem].Checked := True;
					end;

			end;
		end;


	{Cool Thing.. assigning on the Fly the BitMaps... for the ImageList...no resource files...}

	IML_TRV_Registry := TImageList.Create(V_Form);
	IML_TRV_Registry.Width := V_FolderWidth;
	IML_TRV_Registry.Height := V_FolderHeight;


	V_Bitmap := TBitMap.Create;

	V_BitMap.Height := V_FolderHeight;
	V_BitMap.Width := V_FolderWidth;
	Counter := 1;

	for x := 0 to V_BitMap.Width - 1do
		begin
			for y := 0 to V_BitMap.Height - 1 do
				begin
					V_BitMap.Canvas.Pixels[x,y] := V_Folder[Counter];
					inc(Counter);
				end;
		end;

	IML_TRV_Registry.Add(V_BitMap,nil);
	V_BitMap.Free;



	V_Bitmap := TBitMap.Create;

	V_BitMap.Height := V_BinaryHeight;
	V_BitMap.Width := V_BinaryWidth;
	Counter := 1;

	for x := 0 to V_BitMap.Width - 1  do
		begin
			for y := 0 to V_BitMap.Height - 1 do
				begin
					V_BitMap.Canvas.Pixels[x,y] := V_Binary[Counter];
					inc(Counter);
				end;
		end;

	IML_TRV_Registry.Add(V_BitMap,nil);
	V_BitMap.Free;

	V_Bitmap := TBitMap.Create;

	V_BitMap.Height := V_StringHeight;
	V_BitMap.Width := V_StringWidth;
	Counter := 1;

	for x := 0 to V_BitMap.Width - 1 do
		begin
			for y := 0 to V_BitMap.Height - 1 do
				begin
					V_BitMap.Canvas.Pixels[x,y] := V_String[Counter];
					inc(Counter);
				end;
		end;

	IML_TRV_Registry.Add(V_BitMap,nil);
	V_BitMap.Free;



	V_TRV_Registry := TTreeView.Create(V_PAN_Form);
	V_TRV_Registry.Parent := V_PAN_Form;
	V_TRV_Registry.Left := 8;
	V_TRV_Registry.Top := 12;
	V_TRV_Registry.Width := 233;
	V_TRV_REgistry.Height := 117;
	V_TRV_Registry.HideSelection := False;
	V_TRV_Registry.ReadOnly := True;
	V_TRV_Registry.RowSelect := True;
	V_TRV_Registry.TabOrder := 9;
	V_TRV_Registry.Images := IML_TRV_REgistry;

	V_TRV_Registry.Items.Clear;

	case V_RootKey of
		rgk_HKEY_CLASSES_ROOT:
			begin
				V_Node := V_TRV_Registry.Items.Add(V_TRV_Registry.Selected,'HKEY_CLASSES_ROOT');
			end;
		rgk_HKEY_CURRENT_USER:
			begin
				V_Node := V_TRV_Registry.Items.Add(V_TRV_Registry.Selected,'HKEY_CURRENT_USER');
			end;
		rgk_HKEY_LOCAL_MACHINE:
			begin
				V_Node := V_TRV_Registry.Items.Add(V_TRV_Registry.Selected,'HKEY_LOCAL_MACHINE');
			end;
		rgk_HKEY_CURRENT_CONFIG:
			begin
				V_Node := V_TRV_Registry.Items.Add(V_TRV_Registry.Selected,'HKEY_CURRENT_CONFIG');
			end;
		else
			begin
				V_Node := V_TRV_Registry.Items.Add(V_TRV_Registry.Selected,'--- CORRUPTED ----');
			end;
	end;

	V_NodeStore := V_Node;
	V_Node.ImageIndex := 0;
	V_Node.SelectedIndex := 0;

	for NumeroItem := 0 to V_REgistryKeys.Count - 1 do
		begin
			V_Node := V_TRV_Registry.Items.AddChild(V_Node,V_RegistryKeys.Items[NumeroItem].RegistryKey);
			V_Node.ImageIndex := 0;
			V_Node.SelectedIndex := 0;
		end;

	V_Node := V_TRV_Registry.Items.AddChild(V_Node,V_VariableName);
	V_Node.ImageIndex := 2;
	V_Node.SelectedIndex := 2;

	V_NodeStore.Expand(True);


	V_Form.ShowModal;

	MessageDlg('The File was Successfully Imported.',mtInformation,[mbOk],0);

end;


procedure TARERegistryVariable.ExportFile;
var
	V_SaveDialog			: TSaveDialog;
	Fichero					: TextFile;
	KeyString				: string;
	NumeroItem				: integer;
begin
	if V_RegistryKeys.Count = 0 then
		begin
			MEssageDlg('There is nothing to Export.',mtInformation,[mbOk],0);
			exit;
		end;

	V_SaveDialog := TSaveDialog.Create(nil);
	V_SaveDialog.DefaultExt := '*.reg';
	V_SaveDialog.Filter := 'Registry Exported Files (*.reg)|*.reg';
	V_SaveDialog.Options := [ofOverwritePrompt,ofHideReadOnly,ofEnableSizing];
	V_SaveDialog.InitialDir := '';
	V_SaveDialog.Title := 'Select Registry Save File';
	if V_SaveDialog.Execute then
		begin
			AssignFile(Fichero,V_SaveDialog.FileName);
			Rewrite(Fichero);

			writeln(Fichero,'REGEDIT4');
			writeln(Fichero,'');

			KeyString := '';
			case V_RootRegistryKey of
				rgk_HKEY_CLASSES_ROOT	: KeyString := '[HKEY_CLASSES_ROOT\';
				rgk_HKEY_CURRENT_USER	: KeyString := '[HKEY_CURRENT_USER\';
				rgk_HKEY_LOCAL_MACHINE	: KeyString := '[HKEY_LOCAL_MACHINE\';
				rgk_HKEY_CURRENT_CONFIG	: KeyString := '[HKEY_CURRENT_CONFIG\';
			end;


			for NumeroItem := 0 to V_RegistryKeys.Count - 1 do
				begin
					if NumeroItem <> V_RegistryKeys.Count - 1 then
						KeyString := KeyString + V_RegistryKeys.Items[NumeroItem].RegistryKey + '\'
					else
						KeyString := KeyString + V_RegistryKeys.Items[NumeroItem].RegistryKey + ']'
				end;

			writeln(Fichero,KeyString);


			if V_VariableName = '' then
				begin
					writeln(Fichero,'@=""');
				end
			else
				begin
					writeln(Fichero,Format('"%s"=""',[V_VariableName]));
				end;

			Closefile(Fichero);

			MessageDlg(Format('Data Successfully Exported to File (%s).',[V_SaveDialog.filename]),mtInformation,[mbOk],0);

		end;

	V_SaveDialog.Free;

end;

procedure TARERegistryVariable.ShowValue;
var
		V_BitMap				: TBitMap;
		Counter					: integer;
		X,Y						: integer;
		NumeroItem				: integer;
		V_Value					: Variant;
		V_NodeStore				: TTreeNode;
begin
	{Creating the Form}
	V_Form := TForm.Create(Nil);
	V_Form.BorderStyle := bsNone;
	V_Form.Caption := '';
	V_Form.Position := poScreenCenter;
	V_Form.Width := 373;
	V_Form.Height := 225;

	{Creating Panel}
	V_PAN_Form := TPanel.Create(V_Form);
	V_PAN_Form.Parent := V_Form;
	V_PAN_Form.Caption := '';
	V_PAN_Form.Align := alClient;
	V_PAN_Form.BevelWidth := 3;

	{Label}
	V_LAB_Text := TLabel.Create(V_PAN_Form);
	V_LAB_Text.Parent := V_PAN_Form;
	V_LAB_Text.Left := 8;
	V_LAB_Text.Top := 161;
	V_LAB_Text.Caption := 'Value:';

	{Button}
	V_BTN_Ok := TButton.Create(V_PAN_Form);
	V_BTN_Ok.Parent := V_PAN_Form;
	V_BTN_Ok.Left := 150;
	V_BTN_Ok.Top := 186;
	V_BTN_Ok.Width := 75;
	V_BTN_Ok.Height := 25;
	V_BTN_Ok.Caption := 'Ok';
	V_BTN_Ok.Default := True;
	V_BTN_Ok.TabOrder := 3;
	V_BTN_Ok.OnClick := AR_BTNOkClick;

	{EditBox}
	V_EDT_Value := TEdit.Create(V_PAN_Form);
	V_EDT_Value.Parent := V_PAN_Form;
	V_EDT_Value.Text := '';
	V_EDT_Value.Left := 42;
	V_EDT_Value.Top := 157;
	V_EDT_Value.Width := 323;
	V_EDT_Value.Height := 25;
	V_EDT_Value.TabOrder := 2;
	V_EDT_Value.ReadOnly := True;

	{Cool Thing.. assigning on the Fly the BitMaps... for the ImageList...no resource files...}

	IML_TRV_Registry := TImageList.Create(V_Form);
	IML_TRV_Registry.Width := V_FolderWidth;
	IML_TRV_Registry.Height := V_FolderHeight;


	V_Bitmap := TBitMap.Create;

	V_BitMap.Height := V_FolderHeight;
	V_BitMap.Width := V_FolderWidth;
	Counter := 1;

	for x := 0 to V_BitMap.Width - 1do
		begin
			for y := 0 to V_BitMap.Height - 1 do
				begin
					V_BitMap.Canvas.Pixels[x,y] := V_Folder[Counter];
					inc(Counter);
				end;
		end;

	IML_TRV_Registry.Add(V_BitMap,nil);
	V_BitMap.Free;



	V_Bitmap := TBitMap.Create;

	V_BitMap.Height := V_BinaryHeight;
	V_BitMap.Width := V_BinaryWidth;
	Counter := 1;

	for x := 0 to V_BitMap.Width - 1  do
		begin
			for y := 0 to V_BitMap.Height - 1 do
				begin
					V_BitMap.Canvas.Pixels[x,y] := V_Binary[Counter];
					inc(Counter);
				end;
		end;

	IML_TRV_Registry.Add(V_BitMap,nil);
	V_BitMap.Free;

	V_Bitmap := TBitMap.Create;

	V_BitMap.Height := V_StringHeight;
	V_BitMap.Width := V_StringWidth;
	Counter := 1;

	for x := 0 to V_BitMap.Width - 1 do
		begin
			for y := 0 to V_BitMap.Height - 1 do
				begin
					V_BitMap.Canvas.Pixels[x,y] := V_String[Counter];
					inc(Counter);
				end;
		end;

	IML_TRV_Registry.Add(V_BitMap,nil);
	V_BitMap.Free;



	V_TRV_Registry := TTreeView.Create(V_PAN_Form);
	V_TRV_Registry.Parent := V_PAN_Form;
	V_TRV_Registry.Left := 5;
	V_TRV_Registry.Top := 7;
	V_TRV_Registry.Width := 362;
	V_TRV_REgistry.Height := 146;
	V_TRV_Registry.HideSelection := False;
	V_TRV_Registry.ReadOnly := True;
	V_TRV_Registry.RowSelect := True;
	V_TRV_Registry.TabOrder := 1;
	V_TRV_Registry.Images := IML_TRV_REgistry;

	V_TRV_Registry.Items.Clear;

	case V_RootRegistryKey of
		rgk_HKEY_CLASSES_ROOT:
			begin
				V_Node := V_TRV_Registry.Items.Add(V_TRV_Registry.Selected,'HKEY_CLASSES_ROOT');
			end;
		rgk_HKEY_CURRENT_USER:
			begin
				V_Node := V_TRV_Registry.Items.Add(V_TRV_Registry.Selected,'HKEY_CURRENT_USER');
			end;
		rgk_HKEY_LOCAL_MACHINE:
			begin
				V_Node := V_TRV_Registry.Items.Add(V_TRV_Registry.Selected,'HKEY_LOCAL_MACHINE');
			end;
		rgk_HKEY_CURRENT_CONFIG:
			begin
				V_Node := V_TRV_Registry.Items.Add(V_TRV_Registry.Selected,'HKEY_CURRENT_CONFIG');
			end;
		else
			begin
				V_Node := V_TRV_Registry.Items.Add(V_TRV_Registry.Selected,'--- CORRUPTED ----');
			end;
	end;

	V_NodeStore := V_Node;
	V_Node.ImageIndex := 0;
	V_Node.SelectedIndex := 0;

	for NumeroItem := 0 to V_REgistryKeys.Count - 1 do
		begin
			V_Node := V_TRV_Registry.Items.AddChild(V_Node,V_RegistryKeys.Items[NumeroItem].RegistryKey);
			V_Node.ImageIndex := 0;
			V_Node.SelectedIndex := 0;
		end;

	V_Node := V_TRV_Registry.Items.AddChild(V_Node,V_VariableName);
	V_Node.ImageIndex := 2;
	V_Node.SelectedIndex := 2;

	if ExistVariable then
		begin
			V_Value := Read;
		end
	else
		begin
			V_Value := '(Variable not Created)';
		end;


	case VarType(V_Value) of
		varString:
			begin
				V_EDT_Value.Text := V_Value;
			end;
		varEmpty,varNull:
			begin
				V_EDT_Value.Text := '';
			end;
		varInteger,varSmallInt:
			begin
				V_EDT_Value.Text := IntToStr(V_Value);
			end;
		varCurrency,varDouble:
			begin
				V_EDT_Value.Text := FormatFloat('###,###,###,###.0000',V_Value);
			end;
		varDate:
			begin
				V_EDT_Value.Text := FormatDateTime('dd/mm/yyyy hh:mm:ss',V_Value);
			end;
		varBoolean:
			begin
				case V_Value of
					-1:
						begin
							V_EDT_Value.Text := 'True';
						end;
					0:
						begin
							V_EDT_Value.Text := 'False';
						end;
				end;
			end;
		else
			begin
				V_EDT_Value.Text := '(unreadable)';
			end;
	end;

	V_NodeStore.Expand(True);

	V_Form.ShowModal;

end;


function TARERegistryVariable.ExistVariable: boolean;
var
	NumeroItem				: integer;
	Reg						: TRegistry;
begin
	if V_RegistryKeys.Count = 0 then
		begin
			ExistVariable := False;
			exit;
		end;

	Reg := TRegistry.Create;

	case V_RootRegistryKey of
		rgk_HKEY_CLASSES_ROOT: Reg.RootKey := HKEY_CLASSES_ROOT;
		rgk_HKEY_CURRENT_USER: Reg.RootKey := HKEY_CURRENT_USER;
		rgk_HKEY_LOCAL_MACHINE: Reg.RootKey := HKEY_LOCAL_MACHINE;
		rgk_HKEY_CURRENT_CONFIG: Reg.RootKey := HKEY_CURRENT_CONFIG;
	end;

	NumeroItem := 0;

	repeat
		if not Reg.OpenKey(V_RegistryKeys.Items[NumeroItem].RegistryKey,V_RegistryKeys.Items[NumeroItem].CreateKey) then
			begin
				ExistVariable := False;
				exit;
			end;
		inc(NumeroItem);
	until NumeroItem = V_RegistryKeys.Count;

	ExistVariable := Reg.ValueExists(V_VariableName);
end;

{ TRegistryKeys }

constructor TRegistryKeys.Create(AOwner: TARERegistryVariable);
begin
	inherited Create(TRegistryKey);
	V_Owner := AOwner;
end;


function TRegistryKeys.GetItem(Index: Integer): TRegistryKey;
begin
	Result := TRegistryKey(inherited GetItem(Index));
end;
procedure TRegistryKeys.SetItem(Index: Integer; Value: TRegistryKey);
begin
	inherited SetItem(Index, Value);
end;


function TRegistryKeys.GetOwner: TPersistent;
begin
	Result := V_Owner;
end;

function TRegistryKeys.Add: TRegistryKey;
begin
	Result := TRegistryKey(inherited Add);
end;

procedure TRegistryKeys.Update(Item: TCollectionItem);
begin
//
end;



{ TRegistryKey }

constructor TRegistryKey.Create(Collection: TCollection);
begin
	inherited Create(Collection);
	V_CreateKey := True;

end;

destructor TRegistryKey.Destroy;
begin
	inherited Destroy;
end;

procedure TRegistryKey.Assign(Source: TPersistent);
begin
	inherited Assign(Source);
end;

procedure TRegistryKey.DefineProperties(Filer: TFiler);
begin
	inherited DefineProperties(Filer);
end;


function TRegistryKey.GetDisplayName: string;
begin
	if V_RegistryKey = '' then
		begin
			GetDisplayName := inherited GetDisplayName;
		end
	else
		begin
			GetDisplayName := V_RegistryKey;
		end;

end;

procedure TRegistryKey.PSetV_RegistryKey(const Value: string);
begin
	if Value <> V_RegistryKey then
		begin
			V_RegistryKey := Value;
		end;
end;

procedure TRegistryKey.PSetV_CreateKey(const Value: boolean);
begin
	if Value <> V_CreateKey then
		begin
			V_CreateKey := Value;
		end;
end;

(*  *)

procedure TDialogComponent.ExecuteVerb(Index: Integer);
begin
	case Index of
		0: CopyRight;
		1: DeleteKeyAtRegistry;
		2: DeleteVariable;
		3: ImportFile;
		4: ExportFile;
		5: ShowValue;
	end;
end;

function TDialogComponent.GetVerb(Index: Integer): String;
begin
	case Index of
		0: Result := 'Albert Research 98';
		1: Result := 'Delete Key At Registry';
		2: Result := 'Delete Variable';
		3: Result := 'Import from File';
		4: Result := 'Export to File';
		5: Result := 'Show Value';
	end;
end;

function TDialogComponent.GetVerbCount: Integer;
begin
	Result := 6;
end;

procedure TDialogComponent.CopyRight;
begin
	TARERegistryVariable(Component).CopyRight;
end;

procedure TDialogComponent.ImportFile;
var
	V_OpenDialog			: TOpenDialog;
	Fichero					: TextFile;
	Linea					: string;
	IsRegFile				: boolean;
	KeyString				: string;
	ValueString				: string;
begin
	if TARERegistryVariable(Component).KeyCount > 0 then
		begin
			if MessageDlg('There is a Current Key Structure Created at the Object. This will be deleted by Importing a Registry File. Do you wish to continue',mtWarning,[mbYes,mbNo],0) = mrNo then
				begin
					MessageBeep(1);
					exit;
				end;
		end;

	V_OpenDialog := TOpenDialog.Create(nil);
	V_OpenDialog.DefaultExt := '*.reg';
	V_OpenDialog.Filter := 'Registry Exported Files (*.reg)|*.reg';
	V_OpenDialog.Options := [ofHideReadOnly,ofPathMustExist,ofFileMustExist,ofEnableSizing];
	V_OpenDialog.InitialDir := '';
	V_OpenDialog.Title := 'Select Registry Exported File';
	if V_OpenDialog.Execute then
		begin
			if not FileExists(V_OpenDialog.FileName) then
				begin
					MessageDlg(Format('Exported Registry File (%s) does not exist. Importing Cancelled.',[V_OpenDialog.FileName]),mtError,[mbOk],0);
					exit;
				end;

			IsRegFile := False;
			AssignFile(Fichero,V_OpenDialog.FileName);
			Reset(Fichero);
			while not EOF(Fichero) do
				begin
					readln(Fichero,Linea);
					{First Line MUST BE REGEDIT4}
					if Pos('REGEDIT4',Linea) = 0 then
						begin
							IsRegFile := False;
							break;
						end;
					{Ignore SecondLine}
					readln(Fichero,Linea);

					{Third Line. This Line must be the Keys Line splitted in '\'}
					readln(Fichero,Linea);
					if Length(Linea) < 19 {Length of the smallest rootkey HKEY_CURRENT_USER + 2 of the brakets} then
						begin
							IsRegFile := False;
							break;

						end;
					if (Linea[1] <> '[') OR (Linea[Length(Linea)] <> ']') then
						begin
							IsRegFile := False;
							break;
						end;

					KeyString := Linea;

					{Fourth Line Must be the Value}
					readln(Fichero,Linea);

					{if Line is Blank then no Variable is Created because it is the default value}
					if Linea = '' then
						begin
							ValueString := '';
						end
					else
						begin
							{4 is the minimun length for a Value at the registry or if there is no equa sign then abort}
							if (Length(Linea) < 4) OR (Pos('=',Linea) = 0) then
								begin
									IsRegFile := False;
									break;
								end;

							ValueString := Linea;
						end;
					IsRegFile := True;
					{The rest will be ignored}
					break;
				end;

			CloseFile(Fichero);

			if not IsRegFile then
				begin
					MessageDlg(Format('File (%s) is not a Valid Registry Exportation File. Importing Cancelled.',[V_OpenDialog.FileName]),mtError,[mbOk],0);
					exit;
				end
			else
				begin
					TARERegistryVariable(Component).ImportFile(KeyString,ValueString);
				end;

		end;

	V_OpenDialog.Free;

end;

procedure TDialogComponent.ExportFile;
begin
	TARERegistryVariable(Component).ExportFile;
end;


procedure TDialogComponent.DeleteVariable;
begin
	TARERegistryVariable(Component).DeleteVariable;
end;

procedure TDialogComponent.ShowValue;
begin                                           
	TARERegistryVariable(Component).ShowValue;
end;


procedure TDialogComponent.DeleteKeyAtRegistry;
var
	V_IndexString			: string;
	V_Index					: integer;
	NotInteger				: boolean;
	NumeroItem				: integer;
begin
	if (TARERegistryVariable(Component).KeyCount = 0) then
		exit;

	V_IndexString := '0';
	if not InputQuery('Enter Index Number','Key Index (Refered to the Tree Order 0 = First)',V_IndexString) then
		begin
			MessageBeep(1);
			exit;
		end;

	if V_IndexString = '' then
		begin
			MessageDlg('You did not entered nothing. Exiting.',mtError,[mbOk],0);
			exit;
		end;

	NotInteger := False;
	NumeroItem := 1;

	repeat
		if (V_IndexString[NumeroItem] < #48) OR (V_IndexString[NumeroItem] > #57) then
			begin
				NotInteger := True;
				break;
			end;
			inc(NumeroItem);
	until NumeroItem > Length(V_IndexString);

	if NotInteger then
		begin
			MessageDlg('You must enter a correct Integer Value. Exiting.',mtError,[mbOk],0);
			exit;
		end;

	V_Index := StrToIntDef(V_IndexString,0);

	if (V_Index < 0 ) OR (V_Index > TARERegistryVariable(Component).KeyCount) then
		begin
			MessageDlg('Index Value Entered is out of Key Bounds. Exiting.',mtError,[mbOk],0);
			exit;
		end;


	TARERegistryVariable(Component).DeleteKeyAtRegistry(V_Index);

end;

procedure TAboutProperty.Edit;
var
	VForm				: TForm;
	VButton				: TButton;
	VLabel				: TLabel;
	VLabel1				: TARUrlLabel;
	VLabel2				: TARUrlLabel;
	VImage				: TImage;

	Counter				: integer;
	x,y					: integer;
begin
	VForm := TForm.Create(nil);
	VButton := TButton.Create(VForm);
	VLabel := TLabel.Create(VForm);
	VLabel1 := TARUrlLabel.Create(VForm);
	VLabel2 := TARUrlLabel.Create(VForm);
	VImage := TImage.Create(VForm);

	VButton.Width := 60;
	VButton.Height := 21;
	VButton.Left := 126;
	VButton.Top := 120;
	VButton.Caption := 'Ok';
	VButton.ModalResult := mrOk;
	Vbutton.Parent := VForm;

	VLabel.Width := 252;
	VLabel.Height := 205;
	VLabel.Left := 64;
	VLabel.Top := 4;
	VLabel.AutoSize := False;
	VLabel.Caption := 'ARERegistryVariable. An Enhanced ARRegistryVaria-'+#10
					 +'ble Object. Now you can Store you Variables at any'+#10
					 +'Place at the Registry.'+#10#10+'E-Mail:'+#10#10+'WWW:';
	VLabel1.Left := 100;
	VLabel1.Top := 56;

	VLabel2.Left := 100;
	VLabel2.Top := 82;

	VLabel1.Url := 'albertrs@redestb.es';
	VLabel1.Caption := 'albertrs@redestb.es';
	VLabel1.UrlType := url_mailto;

	VLabel2.Url := 'http://personal.redestb.es/albertrs';
	VLabel2.Caption := 'http://personal.redestb.es/albertrs';
	VLabel2.URLType := url_http;

	VLabel.Parent := VForm;
	VLabel1.Parent := VForm;
	VLabel2.Parent := VForm;
	VImage.Parent := VForm;
	VImage.Transparent := True;

	VImage.Top := 10;
	VImage.Left := 10;


	Counter := 1;
	VImage.Picture.BitMap.Height := V_AlbertResearchHeight;
	VImage.Picture.BitMap.Width := V_AlbertResearchWidth;	

	for x := 0 to VImage.Picture.BitMap.Width - 1 do
		begin
			for y := 0 to VImage.Picture.BitMap.Height - 1 do
				begin
					VImage.Picture.BitMap.Canvas.Pixels[x,y] := V_AlbertResearch[Counter];
					inc(Counter);
				end;
		end;


	VForm.BorderStyle := bsToolWindow;
	VForm.Width := 324;
	VForm.Height := 170;
	VForm.Position := poScreenCenter;
	VForm.Caption := 'Albert Research 98 ARERegistryVariable V1.0';
	VForm.ShowModal;

end;

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
	Result := [paMultiSelect, paDialog, paReadOnly];
end;

function TAboutProperty.GetValue: string;
begin
	Result := 'Albert Research 98';
end;

constructor TARUrlLabel.Create(AOwner : TComponent);
begin
	inherited Create(AOwner);
	VUrl := 'http://personal.redestb.es/albertrs/';
	VUrlType := url_http;
	Hint := VUrl;
	ParentShowHint := False;
	ShowHint := True;
	OnClick := AR_DoClick;
	Font.Style := [fsUnderline];
	Font.Color := clBlue;
	Cursor := crHandPoint;
	Caption := 'Albert Research 98';

end;

destructor TARUrlLabel.Destroy;
begin
	inherited Destroy;

end;

procedure TARUrlLabel.AR_DoClick(Sender:TObject);
begin
{$ifdef win32}
	case VUrlType of
		url_http:
			begin
				ShellExecute(TForm(Owner).Handle, 'open', PChar(VURL), nil, nil, SW_SHOW);
			end;
		url_mailto:
			begin
				ShellExecute(TForm(Owner).Handle, 'open', PChar('mailto:'+VURL), nil, nil, SW_SHOW);
			end;
	end;
{$endif}
end;

procedure TARUrlLabel.PSetVUrl(Value: string);
begin
	if Value <> VUrl then
		begin
			VUrl := Value;
			Hint := VUrl;
		end;
end;

procedure TARUrlLabel.PSetVUrlType(Value: TARUrlType);
begin
	if Value <> VUrlType then
		begin
			VUrlType := Value;
		end;
end;

end.
